local dbversion = 7 -- increment this everytime you move a spellid around or fix the db other than adding to it this will reset the mounts db so that errors will be omitted

local L = LibStub("AceLocale-3.0"):GetLocale("Mounted", false)

Mounted = CreateFrame("frame")
local Mounted = Mounted
Mounted:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
Mounted:SetScript("OnUpdate", function(self, ...) if self['MountCheck'] then return self['MountCheck'](self, ...) end end)
Mounted:RegisterEvent("ADDON_LOADED")
function Mounted:Print(...) ChatFrame1:AddMessage(string.join(" ", "|cFF33FF99Mounted|r:", ...)) end

function Mounted:ADDON_LOADED(event, addon)
	if addon:lower() ~= "mounted" then return end
	local _, class = UnitClass("player")
	for k in pairs (self.macros[class]) do
		for name, macro in pairs (self.macros[class][k]) do
			self.macros['GENERAL'][k][name] = macro
		end
	end
	self.locked = {}
	for k in pairs (self.macros['GENERAL']) do
		self.locked[k] = {}
		for name in pairs (self.macros['GENERAL'][k]) do
			self.locked[k][name] = true
		end
	end
	if 'DRUID' == class then
		self.spellmounts = {}
		self.spellmounts[40120] = 'f,280' --swift flight
		self.spellmounts[33943] = 'f,60' --flight
		self.spellmounts[783] = 'g,40' --travel
		self.spellmounts[1066] = 'a,50' --aquatic
	elseif 'SHAMAN' == class then
		self.spellmounts = {}
		self.spellmounts[2645] = 'g,40' --travel
	end
	if class == 'DRUID' or class == 'SHAMAN' then
		Mounted.MountCheck = Mounted.MountCheckInsta
	else
		Mounted.MountCheckInsta = nil
	end
	defaults = {
		['class'] = {
			f = 'Default',
			g = 'Default',
			aq = 'Default',
			cm = 'Default',
		},
		['char'] = {
			floc = 'class',
			gloc = 'class',
			aqloc = 'class',
			cmloc = 'class',
			mounts = {['g']={['100']={}, ['60']={}, ['40']={}, ['0']={}, ['aq']={},}, ['f']={['310']={}, ['280']={}, ['60']={},}, ['a']={['50']={},},}
		},
		['global'] = {
			['macros'] = self.macros['GENERAL'],
		}
	}
	self.db = LibStub("AceDB-3.0"):New("MountedDB", defaults, 'class')
	self.db.char.mounts = self.db.char.mounts or newmounts
	
	if not self.db.char.dbversion or self.db.char.dbversion < dbversion then
		self:Print(L["DBerror"])
		self.db.char.mounts = {['g']={['100']={}, ['60']={}, ['40']={}, ['0']={}, ['aq']={},}, ['f']={['310']={}, ['280']={}, ['60']={},}, ['a']={['50']={},},}
		self.db.char.dbversion = dbversion
	end
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
	if IsLoggedIn() then self:PLAYER_LOGIN() else self:RegisterEvent("PLAYER_LOGIN") end
	SLASH_Mounted1 = "/mounted";
	SLASH_Mounted2 = "/mnt";
	SlashCmdList["Mounted"] = function()
		InterfaceOptionsFrame_OpenToCategory(self.optframe.Mounted)
	end
end

local L_DALARAN
local L_WINTERGRASP

function Mounted:PLAYER_LOGIN()
	L_DALARAN = select(3,GetMapZones(4))
	L_WINTERGRASP = select(10,GetMapZones(4))
	if GetMacroIndexByName("Mounted") == 0 then
		CreateMacro("Mounted", 1, '')
	end
	self:CheckDB()
	self:RegisterEvent("LEARNED_SPELL_IN_TAB")
	for i=1,4 do
		self:LEARNED_SPELL_IN_TAB(event, i)
	end
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("COMPANION_LEARNED")
	self:RegisterEvent("ZONE_CHANGED")
	self:RegisterEvent("ZONE_CHANGED_INDOORS")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	self:RegisterEvent("MINIMAP_UPDATE_ZOOM")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:UnregisterEvent("PLAYER_LOGIN")
	self.PLAYER_LOGIN = nil
end

function Mounted:LEARNED_SPELL_IN_TAB(event, arg1)
	local update = false
	local _, class = UnitClass("player")
	if arg1 == 1 then
		local _, _, offset, numSpells = GetSpellTabInfo(1);
		for s = offset + 1, offset + numSpells do
			if tostring(string.match(GetSpellLink(GetSpellName(s, BOOKTYPE_SPELL)), "spell:(%d+)")) == '54197' then
				self.ColdWeatherFlying = true
				update = true
				break
			end
		end
		if self.ColdWeatherFlying and ('DRUID' ~= class and 'SHAMAN' ~= class) and update then
			self:UnregisterEvent("LEARNED_SPELL_IN_TAB")
			self:SelectMacro()
		end
	end
	if 'DRUID' == class or 'SHAMAN' == class then
		local _, _, offset, numSpells = GetSpellTabInfo(arg1);
		local spell
		for s = offset + 1, offset + numSpells do
			spell = tonumber(string.match(GetSpellLink(GetSpellName(s, BOOKTYPE_SPELL)), "spell:(%d+)"))
			if self.spellmounts[spell] then
				local spellname = GetSpellInfo(spell)
				local mounttype, mountspeed = string.match(self.spellmounts[spell], '(.),(.+)')
				self.ReverseLookup[spellname] = spell
				self.db.char.mounts[mounttype][mountspeed][spell] = self.db.char.mounts[mounttype][mountspeed][spell] or 5
				if tonumber(mountspeed) then
					if not self.db.char.mounts[mounttype].maxspeed or tonumber(mountspeed) > tonumber(self.db.char.mounts[mounttype].maxspeed) then
						self.db.char.mounts[mounttype].maxspeed = mountspeed
					end
				end
				if spell == '40120' then
					self.spellmounts['33943'] = nil
				end
				self.spellmounts[spell] = nil
				update = true
			end
		end
		if self.ColdWeatherFlying and not next(self.spellmounts) and update then
			self:UnregisterEvent("LEARNED_SPELL_IN_TAB")
			self:SelectMacro()
		end
	end
	self:UpdateOptions()
end

do
	local timer = .25
	local isOutdoorsOld = false
	function Mounted:MountCheck(a1)
		if not InCombatLockdown() then
			timer = timer - a1
			if timer <= 0 then
				timer = .25
				if not isOutdoorsOld and IsOutdoors() then
					isOutdoorsOld = true
					self:SelectMacro()
				elseif isOutdoorsOld and not IsOutdoors() then
					isOutdoorsOld = false
					self:SelectMacro()
				end
			end
		end
	end
	
	local isSwimmingOld = false
	function Mounted:MountCheckInsta(a1)
		if not InCombatLockdown() then
			timer = timer - a1
			if not isSwimmingOld and (IsSwimming() and self.db.char.mounts['a']['50'][1066]) then
				isSwimmingOld = true
				return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(1066)))
			elseif isSwimmingOld and not (IsSwimming() and self.db.char.mounts['a']['50'][1066]) then
				isSwimmingOld = false
				self.isMoving = false
				self:SelectMacro(true)
			end
			if GetUnitSpeed('player') ~= 0 and not IsSwimming() then
				if not self.isMoving then
					self.isMoving = true
					local _, class = UnitClass("player")
					if class == 'SHAMAN' and self.db.char.mounts['g']['40'][2645] and select(7, GetSpellInfo(2645)) == 0 then
						return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(2645)))
					elseif class == 'DRUID' then
						if self:CustIsFlyable() then
							if self.db.char.mounts['f']['280'][40120] then
								local f = GetSpellInfo(40120)
								local g = GetSpellInfo(783)
								return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast [nomodifier] %s; %s', f, g))
							elseif self.db.char.mounts['f']['60'][33943] then
								local f = GetSpellInfo(33943)
								local g = GetSpellInfo(783)
								return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast [nomodifier] %s; %s', f, g))
							elseif self.db.char.mounts['g']['40'][783] then
								return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(783)))
							end
						else
							if self.db.char.mounts['g']['40'][783] then
								return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(783)))
							end
						end
					end
				end
			elseif not IsSwimming() then
				if self.isMoving then
					self.isMoving = false
					self:SelectMacro(true)
				end
			end
			if timer <= 0 then
				timer = .25
				if not isOutdoorsOld and IsOutdoors() then
					isOutdoorsOld = true
					self:SelectMacro()
				elseif isOutdoorsOld and not IsOutdoors() then
					isOutdoorsOld = false
					self:SelectMacro()
				end
			end
		end
	end
end

function Mounted:UNIT_SPELLCAST_SUCCEEDED(event, arg1, arg2)
	if arg1 == 'player' and (arg2 == GetSpellInfo(40120) or arg2 == GetSpellInfo(33943) or arg2 == GetSpellInfo(783) or arg2 == GetSpellInfo(2645))then
		self:SelectMacro(true)
	end
end

function Mounted:UNIT_SPELLCAST_START(event, arg1, arg2)
	if arg1 == 'player' and self.ReverseLookup[arg2] then
		self:SelectMacro(true)
	end
end

function Mounted:PLAYER_REGEN_DISABLED()
	self:CombatMacro()
	self.isMoving = false
end

function Mounted:PLAYER_REGEN_ENABLED()
	self:SelectMacro()
end

function Mounted:ZONE_CHANGED()
	self:SelectMacro()
end

function Mounted:ZONE_CHANGED_INDOORS()
	self:SelectMacro()
end

function Mounted:ZONE_CHANGED_NEW_AREA()
	self:SelectMacro()
end

function Mounted:MINIMAP_UPDATE_ZOOM()
	self:SelectMacro()
end

function Mounted:COMPANION_LEARNED()
	self:Scan()
end

do
	local macrotype
	function Mounted:CustIsFlyable()
		local flyable
		local mapContinent = GetCurrentMapContinent()
		local mapZone = GetCurrentMapZone()
		SetMapToCurrentZone()
		local currentcontinent = GetCurrentMapContinent()
		if currentcontinent == 3 or (currentcontinent == 4 and self.ColdWeatherFlying and (GetRealZoneText() ~= L_DALARAN or GetSubZoneText() == L["Krasus' Landing"] or GetSubZoneText() == L["The Underbelly"]) and GetRealZoneText() ~= L_WINTERGRASP) then
			flyable = true
		else
			flyable = false
		end
		SetMapZoom(mapContinent, mapZone)
		return flyable
	end
	
	function Mounted:SelectMacro(overwrite)
		if not InCombatLockdown() and not self.isMoving then
			if overwrite then macrotype = nil end
			local newmacrotype
			if self.db.char.mounts['f'].maxspeed and IsFlyableArea() and IsOutdoors() then
				if self:CustIsFlyable() then
					newmacrotype = 'AirMacro'
				else
					newmacrotype = 'GroundMacro'
				end
			elseif self.db.char.mounts['g'].maxspeed and IsOutdoors() then
				newmacrotype = 'GroundMacro'
			else
				newmacrotype = 'CombatMacro'
			end
			if macrotype ~= newmacrotype then
				macrotype = newmacrotype
				Mounted[macrotype](Mounted)
			end
		end
	end
	
	function Mounted:CombatMacro()
		macrotype = 'CombatMacro'
		self:ParseMacro(self.db.global.macros.cm[self.db[self.db.char.cmloc].cm])
	end
	
	function Mounted:GetRandomMount(mtype, mspeed)
		if mspeed == 'f' then mspeed = self.db.char.mounts[mtype].maxspeed end
		local mounts = {}
		for k, priority in pairs(self.db.char.mounts[mtype][mspeed]) do
			if priority ~= 0 then
				for i=1, priority do
					mounts[#mounts+1] = k
				end
			end
		end
		if not next(mounts) then mounts[1] = next(self.db.char.mounts[mtype][mspeed]) end -- should resolve edge case where all priorities where set to 0
		local randmount = GetSpellInfo(mounts[math.random(1,#mounts)])
		return randmount..'()'
	end

	function Mounted:GroundMacro()
		if GetRealZoneText() == L["Temple of Ahn'Qiraj"] then
			if next(self.db.char.mounts['g']['aq']) then
				self:ParseMacro(self.db.global.macros.aq[self.db[self.db.char.aqloc].aq])
			else
				self:SelectMacro(true)
			end
		else
			self:ParseMacro(self.db.global.macros.g[self.db[self.db.char.gloc].g])
		end
	end

	function Mounted:AirMacro()
		self:ParseMacro(self.db.global.macros.f[self.db[self.db.char.floc].f])
	end
	
	function Mounted:ParseMacro(macrotext, preview)
		local mounts = {}
		local mountscache = {}
		for mtype, mspeed in string.gmatch(macrotext, "<(%a)(%w+)>") do
			if mtype == 's' then
				mounts[#mounts+1] = GetSpellInfo(mspeed)
			else
				if not mountscache[mtype..mspeed] then
					mountscache[mtype..mspeed] = self:GetRandomMount(mtype, mspeed)
				end
				mounts[#mounts+1] = mountscache[mtype..mspeed]
			end
		end
		macrotext = string.format(string.gsub(macrotext, '<%w+>', '%%s'), unpack(mounts))
		if preview then
			return macrotext
		end
		EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, macrotext)
	end
end

Mounted.ReverseLookup = {}
function Mounted:Scan()
	local creatureName, creatureSpellID, mounttype, mountspeed
	for id = 1,GetNumCompanions("MOUNT") do
		creatureSpellID = select(3, GetCompanionInfo("MOUNT", id))
		creatureName = GetSpellInfo(creatureSpellID);
		Mounted.ReverseLookup[creatureName] = creatureSpellID
		local mountpack = self:MountType(creatureSpellID)
		if mountpack[1] then
			for i=1,#mountpack/2 do
				self.db.char.mounts[mountpack[i*2-1]][mountpack[i*2]][creatureSpellID] = self.db.char.mounts[mountpack[i*2-1]][mountpack[i*2]][creatureSpellID] or 5
				if tonumber(mountpack[i*2]) then
					if not self.db.char.mounts[mountpack[i*2-1]].maxspeed or (tonumber(mountpack[i*2]) > tonumber(self.db.char.mounts[mountpack[i*2-1]].maxspeed) and not (#mountpack > 2)) then
						self.db.char.mounts[mountpack[i*2-1]].maxspeed = mountpack[i*2]
					end
				end
			end
		else
			self:Print(creatureName..' with SpellID of '..creatureSpellID..' was not parsable sry!')
		end
	end
	self:UpdateOptions()
	self:SelectMacro()
end

local MountIdsLookup = {}
function Mounted:GetAllids()
	for id = 1,GetNumCompanions("MOUNT") do
		local creatureSpellID = select(3, GetCompanionInfo("MOUNT", id)) 
		MountIdsLookup[creatureSpellID] = true
	end
end

function Mounted:CheckDB()
	self:GetAllids()
	for mtype in pairs(self.db.char.mounts) do
		for mspeed in pairs(self.db.char.mounts[mtype]) do
			if mspeed ~= 'maxspeed' then
				for spellid in pairs(self.db.char.mounts[mtype][mspeed]) do
					if MountIdsLookup[spellid] then
						local mountpack = self:MountType(spellid)
						local match = false
						for i=1,#mountpack/2 do
							if mountpack[i*2-1] == mtype and mountpack[i*2] == mspeed then
								match = true
							end
						end
						if not match then
							self.db.char.mounts[mtype][mspeed][spellid] = nil
						end
					else
						self.db.char.mounts[mtype][mspeed][spellid] = nil
					end
				end
			else
				self.db.char.mounts[mtype][mspeed] = nil
			end
		end
	end
	self:Scan()
	MountIdsLookup = nil
	self.GetAllids = nil
	self.CheckDB = nil
end

